import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:s10s_card_scanner/s10s_card_scanner.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _cardNumber = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    try {
      final results = await S10sCardScanner.cardScanInfo;
      _cardNumber = results?['cardNumber'] ?? "";
      print(_cardNumber);
    } on Exception {
      print("failed");
    }

    if (!mounted) return;

  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('s10s card scanner plugin example app'),
        ),
        body: Center(
          child: Text('Scanned card number: $_cardNumber\n'),
        ),
      ),
    );
  }
}
